//<copyright-disclaimer-start>
//  **************************************************************************************************************
//  * © 2025 Advanced Micro Devices, Inc. All rights reserved.                                                   *
//  * DISCLAIMER                                                                                                 *
//  * The information contained herein is for informational purposes only, and is subject to change              *
//  * without notice. While every precaution has been taken in the preparation of this document, it              *
//  * may contain technical inaccuracies, omissions and typographical errors, and AMD is under no                *
//  * obligation to update or otherwise correct this information.  Advanced Micro Devices, Inc. makes            *
//  * no representations or warranties with respect to the accuracy or completeness of the contents of           *
//  * this document, and assumes no liability of any kind, including the implied warranties of noninfringement,  *
//  * merchantability or fitness for particular purposes, with respect to the operation or use of AMD            *
//  * hardware, software or other products described herein.  No license, including implied or                   *
//  * arising by estoppel, to any intellectual property rights is granted by this document.  Terms and           *
//  * limitations applicable to the purchase or use of AMD’s products are as set forth in a signed agreement     *
//  * between the parties or in AMD's Standard Terms and Conditions of Sale. GD-18                               *
//  *                                                                                                            *
//  **************************************************************************************************************
//<copyright-disclaimer-end>


#include "system_settings.h"

using namespace adf;

namespace transform = xf::dsp::aie::fft;

namespace testcase {

class fft_subsystem: public graph {
    private:
		// Instantiate FFT graph
	 	transform::dit_1ch::fft_ifft_dit_1ch_graph<DATA_TYPE,TWIDDLE_TYPE,POINT_SIZE,FFT_DIR,TP_SHIFT,TP_CASC_LEN,TP_DYN_PT_SIZE,TP_WINDOW_VSIZE> fft_gr;

    public:
       input_plio in ;
       output_plio out ;

    fft_subsystem() 
	{
        // Create the PLIO ports
	in = input_plio::create("In", plio_32_bits, "data/data_fft2048/input.txt");
	out = output_plio::create("Out", plio_32_bits, "data/data_fft2048/output.txt");

        // Make connections
    	connect<>(in.out[0],fft_gr.in[0]);
     	connect<>(fft_gr.out[0],out.in[0]);

    }; 
  };

};


