//<copyright-disclaimer-start>
//  **************************************************************************************************************
//  * © 2025 Advanced Micro Devices, Inc. All rights reserved.                                                   *
//  * DISCLAIMER                                                                                                 *
//  * The information contained herein is for informational purposes only, and is subject to change              *
//  * without notice. While every precaution has been taken in the preparation of this document, it              *
//  * may contain technical inaccuracies, omissions and typographical errors, and AMD is under no                *
//  * obligation to update or otherwise correct this information.  Advanced Micro Devices, Inc. makes            *
//  * no representations or warranties with respect to the accuracy or completeness of the contents of           *
//  * this document, and assumes no liability of any kind, including the implied warranties of noninfringement,  *
//  * merchantability or fitness for particular purposes, with respect to the operation or use of AMD            *
//  * hardware, software or other products described herein.  No license, including implied or                   *
//  * arising by estoppel, to any intellectual property rights is granted by this document.  Terms and           *
//  * limitations applicable to the purchase or use of AMD’s products are as set forth in a signed agreement     *
//  * between the parties or in AMD's Standard Terms and Conditions of Sale. GD-18                               *
//  *                                                                                                            *
//  **************************************************************************************************************
//<copyright-disclaimer-end>


#ifndef __GRAPH_H__
#define __GRAPH_H__

#include <adf.h>
#include "dds.h"

class ddsgraph: public adf::graph
{
private:
  adf::kernel dds;

public:
  adf::output_plio out;
  adf::port<adf::direction::in> trigger;

  ddsgraph()
  {
    dds = adf::kernel::create(sine);
    out = adf::output_plio::create("Dataout", adf::plio_32_bits, "data/output.txt");

    //TODO: connect asynchronous runtime parameter


    adf::connect< > net1(dds.out[0], out.in[0]);

    adf::source(dds) = "kernels/dds.cc";
    adf::runtime<adf::ratio>(dds)= 0.9;
  };
};

#endif /* __GRAPH_H__ */
