/*
 * Copyright (C) 2019-2022, Xilinx, Inc.
 * Copyright (C) 2022-2024, Advanced Micro Devices, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/********************************************* Disclaimer *********************************************/
/* This file is generated by aiecompiler . */
/* Changes to this file may cause incorrect behavior and will be lost if aiecompiler is invoked again.*/

#include <iostream>
#include "adf/adf_api/AIEControlConfig.h"
#include "fir_decimate_asym.hpp"

/************************** Graph Configurations  *****************************/

adf::GraphConfig GraphConfigurations[] = {
    //{id, name, graphLoadElfFunc, graphInitFunc, graphDebugHalt, coreColumns, coreRows, iterMemColumns, iterMemRows,
    // iterMemAddrs, triggered, plKernelInstanceNames, plAxiLiteModes, plDriverStartFuncs, plDriverCheckIPDoneFuncs}
    {
        0, "filter", nullptr, nullptr, nullptr, {24}, {0}, {24}, {1}, {0x2d04}, {0}, {}, {}, {}, {},
    },
};
const int NUM_GRAPH = 1;

/************************** PLIO Configurations  *****************************/

adf::PLIOConfig PLIOConfigurations[] = {
    //{id, name, loginal_name, shim_column, slaveOrMaster, streamId}
    {0, "filter.in[0]", "PLIO_in_0_0", 24, 0, 0},
    {1, "filter.out[0]", "PLIO_out_0_0", 24, 1, 0},
};
const int NUM_PLIO = 2;

/************************** ADF API initializer *****************************/

class InitializeAIEControlXRT {
   public:
    InitializeAIEControlXRT() {
        std::cout << "Initializing ADF API..." << std::endl;
#ifdef __EXCLUDE_PL_CONTROL__
        bool exclude_pl_control = true;
#else
        bool exclude_pl_control = false;
#endif
        adf::initializeConfigurations(nullptr, 0, 0, 0, GraphConfigurations, NUM_GRAPH, nullptr, 0, nullptr, 0, nullptr,
                                      0, nullptr, 0, nullptr, 0, nullptr, 0, nullptr, 0, nullptr, 0, PLIOConfigurations,
                                      NUM_PLIO, nullptr, 0, 0, nullptr, false, exclude_pl_control, false, nullptr, true,
                                      2);
    }
} initAIEControlXRT;

#if !defined(__CDO__)

// Kernel Stub Definition
template <>
void xf::dsp::aie::fir::decimate_asym::
    fir_decimate_asym<cint16, short, 9, 3, 15, 0, 384, false, false, 9, 0, 1, 0, 1, 0, 0, 0, 0, 0, 1, 9>::filter(
        adf::io_buffer<cint16,
                       adf::direction::in,
                       adf::io_buffer_config<adf::extents<4294967295>,
                                             adf::locking::sync,
                                             adf::addressing::circular,
                                             adf::margin<16> > >& __restrict,
        adf::io_buffer<cint16,
                       adf::direction::out,
                       adf::io_buffer_config<adf::extents<4294967295>,
                                             adf::locking::sync,
                                             adf::addressing::circular,
                                             adf::margin<4294967295> > >& __restrict) { /* Stub */
}
#endif
