//<copyright-disclaimer-start>
//  **************************************************************************************************************
//  * © 2025 Advanced Micro Devices, Inc. All rights reserved.                                                   *
//  * DISCLAIMER                                                                                                 *
//  * The information contained herein is for informational purposes only, and is subject to change              *
//  * without notice. While every precaution has been taken in the preparation of this document, it              *
//  * may contain technical inaccuracies, omissions and typographical errors, and AMD is under no                *
//  * obligation to update or otherwise correct this information.  Advanced Micro Devices, Inc. makes            *
//  * no representations or warranties with respect to the accuracy or completeness of the contents of           *
//  * this document, and assumes no liability of any kind, including the implied warranties of noninfringement,  *
//  * merchantability or fitness for particular purposes, with respect to the operation or use of AMD            *
//  * hardware, software or other products described herein.  No license, including implied or                   *
//  * arising by estoppel, to any intellectual property rights is granted by this document.  Terms and           *
//  * limitations applicable to the purchase or use of AMD’s products are as set forth in a signed agreement     *
//  * between the parties or in AMD's Standard Terms and Conditions of Sale. GD-18                               *
//  *                                                                                                            *
//  **************************************************************************************************************
//<copyright-disclaimer-end>


#pragma once

#include <adf.h>
#include <fir_sr_sym_graph.hpp>
#include "fir_decimate_hb_graph.hpp"

// Filter parameters
#define DATA_TYPE cint16
#define COEFF_TYPE int16


#define FIR_LEN_HB1 11
#define SHIFT_HB1 16
#define ROUND_MODE_HB1 0

#define FIR_LEN_HB2 15
#define SHIFT_HB2 16
#define ROUND_MODE_HB2 0

#define FIR_LEN_HB3 51
#define SHIFT_HB3 16
#define ROUND_MODE_HB3 0

#define FIR_LEN_CHAN 121
#define SHIFT_CHAN 15
#define ROUND_MODE_CHAN 0

#define WINDOW_SIZE1 1024
#define WINDOW_SIZE2 (WINDOW_SIZE1/2)
#define WINDOW_SIZE3 (WINDOW_SIZE2/2)
#define WINDOW_SIZE_CHAN (WINDOW_SIZE3/2)

// Simulation parameters
#define NUM_ITER 8

