#//<copyright-disclaimer-start>
#//  **************************************************************************************************************
#//  * © 2024 Advanced Micro Devices, Inc. All rights reserved.                                                   *
#//  * DISCLAIMER                                                                                                 *
#//  * The information contained herein is for informational purposes only, and is subject to change              *
#//  * without notice. While every precaution has been taken in the preparation of this document, it              *
#//  * may contain technical inaccuracies, omissions and typographical errors, and AMD is under no                *
#//  * obligation to update or otherwise correct this information.  Advanced Micro Devices, Inc. makes            *
#//  * no representations or warranties with respect to the accuracy or completeness of the contents of           *
#//  * this document, and assumes no liability of any kind, including the implied warranties of noninfringement,  *
#//  * merchantability or fitness for particular purposes, with respect to the operation or use of AMD            *
#//  * hardware, software or other products described herein.  No license, including implied or                   *
#//  * arising by estoppel, to any intellectual property rights is granted by this document.  Terms and           *
#//  * limitations applicable to the purchase or use of AMD’s products are as set forth in a signed agreement     *
#//  * between the parties or in AMD's Standard Terms and Conditions of Sale. GD-18                               *
#//  *                                                                                                            *
#//  **************************************************************************************************************
#//<copyright-disclaimer-end>


#!/usr/bin/ipython

import math
import numpy
import matplotlib.pyplot as plt
from scipy.fftpack import fft, fftshift
#from math import log10 # only supports scalar log10
from numpy import log10 #supports vector log10

data = numpy.loadtxt('out.txt')

cxdata = data[:,0] + data[:,1]*1j
print(cxdata)

n1 = fft(cxdata[0:1023])
n2 = fftshift(n1)
n3 = abs(n2)
n4 = log10(n3)

w1 = fft(cxdata[1024:2047])
w2 = fftshift(w1)
w3 = abs(w2)
w4 = log10(w3)

narrow_spectrum = 20*(n4)
#narrow_spectrum = 20*log10(abs(fftshift(fft(cxdata[0:1023])))) 

wide_spectrum = 20*(w4)
#wide_spectrum = 20*log10(abs(fftshift(fft(cxdata[1024:2047])))) 

plt.plot(wide_spectrum)

plt.savefig('plot_wide.png')

#plt.show()

plt.close()



