//<copyright-disclaimer-start>
//  **************************************************************************************************************
//  * © 2025 Advanced Micro Devices, Inc. All rights reserved.                                                   *
//  * DISCLAIMER                                                                                                 *
//  * The information contained herein is for informational purposes only, and is subject to change              *
//  * without notice. While every precaution has been taken in the preparation of this document, it              *
//  * may contain technical inaccuracies, omissions and typographical errors, and AMD is under no                *
//  * obligation to update or otherwise correct this information.  Advanced Micro Devices, Inc. makes            *
//  * no representations or warranties with respect to the accuracy or completeness of the contents of           *
//  * this document, and assumes no liability of any kind, including the implied warranties of noninfringement,  *
//  * merchantability or fitness for particular purposes, with respect to the operation or use of AMD            *
//  * hardware, software or other products described herein.  No license, including implied or                   *
//  * arising by estoppel, to any intellectual property rights is granted by this document.  Terms and           *
//  * limitations applicable to the purchase or use of AMD’s products are as set forth in a signed agreement     *
//  * between the parties or in AMD's Standard Terms and Conditions of Sale. GD-18                               *
//  *                                                                                                            *
//  **************************************************************************************************************
//<copyright-disclaimer-end>


#include <stdlib.h>
#include <stdio.h>
#include "../dds.h"
#include <aie_api/aie.hpp>
#include <aie_api/aie_adf.hpp>
#include "aie_api/utils.hpp"

static int32 phase_in;

alignas(aie::vector_decl_align) static int16 dds_stored [16] = {32767, 0, 32767, 0, 32767, 0,  32767, 0, 32767, 0, 32767, 0, 32767, 0, 32767, 0};

void init_dds() {
	aie::vector<cint16,8> dds =  aie::load_v<8>((cint16*)dds_stored);
	phase_in = 0;
  
	auto [sin_,cos_] = aie::sincos(phase_in ); // phase_in + 0
	cint16 scvalues={cos_,sin_};
  
	dds.push(scvalues);
	aie::store_v((cint16*)dds_stored, dds);
}

void sine(const int32 phase_increment,output_buffer<cint16,extents<128>> & owin) {
	//Initialize vector from memory
	aie::vector<cint16,8> dds=aie::load_v<8>((cint16*)dds_stored);
	auto owinIter=aie::begin(owin);

	for (unsigned k = 0; k<128; k++){
		phase_in += (phase_increment << 6);
		auto [sin_,cos_] = aie::sincos(phase_in << 14) ; // phase_in + (7i + j + 1) * phase_increment
		cint16 scvalues={cos_,sin_};
		dds.push(scvalues);

		*owinIter++=scvalues;
		aie::store_v((cint16*)dds_stored, dds);
	};
};
