#//<copyright-disclaimer-start>
#//  **************************************************************************************************************
#//  * © 2025 Advanced Micro Devices, Inc. All rights reserved.                                                   *
#//  * DISCLAIMER                                                                                                 *
#//  * The information contained herein is for informational purposes only, and is subject to change              *
#//  * without notice. While every precaution has been taken in the preparation of this document, it              *
#//  * may contain technical inaccuracies, omissions and typographical errors, and AMD is under no                *
#//  * obligation to update or otherwise correct this information.  Advanced Micro Devices, Inc. makes            *
#//  * no representations or warranties with respect to the accuracy or completeness of the contents of           *
#//  * this document, and assumes no liability of any kind, including the implied warranties of noninfringement,  *
#//  * merchantability or fitness for particular purposes, with respect to the operation or use of AMD            *
#//  * hardware, software or other products described herein.  No license, including implied or                   *
#//  * arising by estoppel, to any intellectual property rights is granted by this document.  Terms and           *
#//  * limitations applicable to the purchase or use of AMD’s products are as set forth in a signed agreement     *
#//  * between the parties or in AMD's Standard Terms and Conditions of Sale. GD-18                               *
#//  *                                                                                                            *
#//  **************************************************************************************************************
#//<copyright-disclaimer-end>


validate_bd_design

set curdesign [current_bd_design]
create_bd_design -cell [get_bd_cells /ExtensibleRegion] ExtensibleRegion
current_bd_design $curdesign
set new_cell [create_bd_cell -type container -reference ExtensibleRegion ExtensibleRegion_temp]
replace_bd_cell [get_bd_cells /ExtensibleRegion] $new_cell
delete_bd_objs  [get_bd_cells /ExtensibleRegion]
set_property name ExtensibleRegion $new_cell

current_bd_design [get_bd_designs ExtensibleRegion]
foreach intf [get_bd_intf_ports] {
	set_property HDL_ATTRIBUTE.LOCKED TRUE [get_bd_intf_ports $intf]
}
set_property PFM_NAME {xilinx.com:vck190:flat:0.5} [get_files ExtensibleRegion.bd]

validate_bd_design
save_bd_design

current_bd_design ${curdesign}
upgrade_bd_cells [get_bd_cells ExtensibleRegion]
validate_bd_design
