#//<copyright-disclaimer-start>
#//  **************************************************************************************************************
#//  * © 2025 Advanced Micro Devices, Inc. All rights reserved.                                                   *
#//  * DISCLAIMER                                                                                                 *
#//  * The information contained herein is for informational purposes only, and is subject to change              *
#//  * without notice. While every precaution has been taken in the preparation of this document, it              *
#//  * may contain technical inaccuracies, omissions and typographical errors, and AMD is under no                *
#//  * obligation to update or otherwise correct this information.  Advanced Micro Devices, Inc. makes            *
#//  * no representations or warranties with respect to the accuracy or completeness of the contents of           *
#//  * this document, and assumes no liability of any kind, including the implied warranties of noninfringement,  *
#//  * merchantability or fitness for particular purposes, with respect to the operation or use of AMD            *
#//  * hardware, software or other products described herein.  No license, including implied or                   *
#//  * arising by estoppel, to any intellectual property rights is granted by this document.  Terms and           *
#//  * limitations applicable to the purchase or use of AMD’s products are as set forth in a signed agreement     *
#//  * between the parties or in AMD's Standard Terms and Conditions of Sale. GD-18                               *
#//  *                                                                                                            *
#//  **************************************************************************************************************
#//<copyright-disclaimer-end>


create_project -force flat flat -part xcvc1902-vsva2197-2MP-e-S
set_property board_part xilinx.com:vck190:part0:3.1 [current_project]
create_bd_design "flat"
make_wrapper -files [get_files ./flat/flat.srcs/sources_1/bd/flat/flat.bd] -top
add_files -norecurse ./flat/flat.gen/sources_1/bd/flat/hdl/flat_wrapper.v

source ./flat_pre_bdc.tcl
source ./create_bdc.tcl

set_property -dict [list CONFIG.LOCK_PROPAGATE {true}] [get_bd_cells ExtensibleRegion]

generate_target all [get_files flat.bd]

set_property platform.extensible true [current_project]
set_property platform.platform_state "pre_synth" [current_project]
set_property platform.design_intent.embedded "true" [current_project]
set_property platform.design_intent.server_managed "false" [current_project]
set_property platform.design_intent.external_host "false" [current_project]
set_property platform.design_intent.datacenter "false" [current_project]

update_compile_order -fileset sources_1 
save_bd_design
    
write_hw_platform -force flat_wa.xsa
validate_hw_platform -verbose flat_wa.xsa
